/*
CVE Services API

The CVE Services API supports automation tooling for the CVE Program. Credentials are     required for most service endpoints. Representatives of     <a href='https://www.cve.org/ProgramOrganization/CNAs'>CVE Numbering Authorities (CNAs)</a> should     use one of the methods below to obtain credentials:    <ul><li>If your organization already has an Organizational Administrator (OA) account for the CVE     Services, ask your admin for credentials</li>     <li>Contact your Root (<a href='https://www.cve.org/PartnerInformation/ListofPartners/partner/Google'>Google</a>,     <a href='https://www.cve.org/PartnerInformation/ListofPartners/partner/INCIBE'>INCIBE</a>,     <a href='https://www.cve.org/PartnerInformation/ListofPartners/partner/jpcert'>JPCERT/CC</a>, or     <a href='https://www.cve.org/PartnerInformation/ListofPartners/partner/redhat'>Red Hat</a>) or     Top-Level Root (<a href='https://www.cve.org/PartnerInformation/ListofPartners/partner/icscert'>CISA ICS</a>     or <a href='https://www.cve.org/PartnerInformation/ListofPartners/partner/mitre'>MITRE</a>) to request credentials     </ul>     <p>CVE data is to be in the JSON 5.0 CVE Record format. Details of the JSON 5.0 schema are     located <a href='https://github.com/CVEProject/cve-schema/tree/master/schema/v5.0' target='_blank'>here</a>.</p>    <a href='https://cveform.mitre.org/' class='link' target='_blank'>Contact the CVE Services team</a>

API version: 2.1.4
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package cveapi

import (
	"encoding/json"
)

// checks if the UpdateFullCveRecordResponseUpdatedContainersCna type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &UpdateFullCveRecordResponseUpdatedContainersCna{}

// UpdateFullCveRecordResponseUpdatedContainersCna struct for UpdateFullCveRecordResponseUpdatedContainersCna
type UpdateFullCveRecordResponseUpdatedContainersCna struct {
	Affected *CreateFullCveRecordRequestContainersCnaAffectedInner `json:"affected,omitempty"`
	Descriptions []GetCveRecordResponseContainersCnaDescriptionsInner `json:"descriptions,omitempty"`
	ProblemTypes []GetCveRecordResponseContainersCnaProblemTypesInner `json:"problemTypes,omitempty"`
	ProviderMetadata *GetCveRecordResponseContainersCnaProviderMetadata `json:"providerMetadata,omitempty"`
	References []UpdateFullCveRecordResponseUpdatedContainersCnaReferencesInner `json:"references,omitempty"`
	DataType *string `json:"dataType,omitempty"`
	DataVersion *string `json:"dataVersion,omitempty"`
}

// NewUpdateFullCveRecordResponseUpdatedContainersCna instantiates a new UpdateFullCveRecordResponseUpdatedContainersCna object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewUpdateFullCveRecordResponseUpdatedContainersCna() *UpdateFullCveRecordResponseUpdatedContainersCna {
	this := UpdateFullCveRecordResponseUpdatedContainersCna{}
	return &this
}

// NewUpdateFullCveRecordResponseUpdatedContainersCnaWithDefaults instantiates a new UpdateFullCveRecordResponseUpdatedContainersCna object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewUpdateFullCveRecordResponseUpdatedContainersCnaWithDefaults() *UpdateFullCveRecordResponseUpdatedContainersCna {
	this := UpdateFullCveRecordResponseUpdatedContainersCna{}
	return &this
}

// GetAffected returns the Affected field value if set, zero value otherwise.
func (o *UpdateFullCveRecordResponseUpdatedContainersCna) GetAffected() CreateFullCveRecordRequestContainersCnaAffectedInner {
	if o == nil || IsNil(o.Affected) {
		var ret CreateFullCveRecordRequestContainersCnaAffectedInner
		return ret
	}
	return *o.Affected
}

// GetAffectedOk returns a tuple with the Affected field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *UpdateFullCveRecordResponseUpdatedContainersCna) GetAffectedOk() (*CreateFullCveRecordRequestContainersCnaAffectedInner, bool) {
	if o == nil || IsNil(o.Affected) {
		return nil, false
	}
	return o.Affected, true
}

// HasAffected returns a boolean if a field has been set.
func (o *UpdateFullCveRecordResponseUpdatedContainersCna) HasAffected() bool {
	if o != nil && !IsNil(o.Affected) {
		return true
	}

	return false
}

// SetAffected gets a reference to the given CreateFullCveRecordRequestContainersCnaAffectedInner and assigns it to the Affected field.
func (o *UpdateFullCveRecordResponseUpdatedContainersCna) SetAffected(v CreateFullCveRecordRequestContainersCnaAffectedInner) {
	o.Affected = &v
}

// GetDescriptions returns the Descriptions field value if set, zero value otherwise.
func (o *UpdateFullCveRecordResponseUpdatedContainersCna) GetDescriptions() []GetCveRecordResponseContainersCnaDescriptionsInner {
	if o == nil || IsNil(o.Descriptions) {
		var ret []GetCveRecordResponseContainersCnaDescriptionsInner
		return ret
	}
	return o.Descriptions
}

// GetDescriptionsOk returns a tuple with the Descriptions field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *UpdateFullCveRecordResponseUpdatedContainersCna) GetDescriptionsOk() ([]GetCveRecordResponseContainersCnaDescriptionsInner, bool) {
	if o == nil || IsNil(o.Descriptions) {
		return nil, false
	}
	return o.Descriptions, true
}

// HasDescriptions returns a boolean if a field has been set.
func (o *UpdateFullCveRecordResponseUpdatedContainersCna) HasDescriptions() bool {
	if o != nil && !IsNil(o.Descriptions) {
		return true
	}

	return false
}

// SetDescriptions gets a reference to the given []GetCveRecordResponseContainersCnaDescriptionsInner and assigns it to the Descriptions field.
func (o *UpdateFullCveRecordResponseUpdatedContainersCna) SetDescriptions(v []GetCveRecordResponseContainersCnaDescriptionsInner) {
	o.Descriptions = v
}

// GetProblemTypes returns the ProblemTypes field value if set, zero value otherwise.
func (o *UpdateFullCveRecordResponseUpdatedContainersCna) GetProblemTypes() []GetCveRecordResponseContainersCnaProblemTypesInner {
	if o == nil || IsNil(o.ProblemTypes) {
		var ret []GetCveRecordResponseContainersCnaProblemTypesInner
		return ret
	}
	return o.ProblemTypes
}

// GetProblemTypesOk returns a tuple with the ProblemTypes field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *UpdateFullCveRecordResponseUpdatedContainersCna) GetProblemTypesOk() ([]GetCveRecordResponseContainersCnaProblemTypesInner, bool) {
	if o == nil || IsNil(o.ProblemTypes) {
		return nil, false
	}
	return o.ProblemTypes, true
}

// HasProblemTypes returns a boolean if a field has been set.
func (o *UpdateFullCveRecordResponseUpdatedContainersCna) HasProblemTypes() bool {
	if o != nil && !IsNil(o.ProblemTypes) {
		return true
	}

	return false
}

// SetProblemTypes gets a reference to the given []GetCveRecordResponseContainersCnaProblemTypesInner and assigns it to the ProblemTypes field.
func (o *UpdateFullCveRecordResponseUpdatedContainersCna) SetProblemTypes(v []GetCveRecordResponseContainersCnaProblemTypesInner) {
	o.ProblemTypes = v
}

// GetProviderMetadata returns the ProviderMetadata field value if set, zero value otherwise.
func (o *UpdateFullCveRecordResponseUpdatedContainersCna) GetProviderMetadata() GetCveRecordResponseContainersCnaProviderMetadata {
	if o == nil || IsNil(o.ProviderMetadata) {
		var ret GetCveRecordResponseContainersCnaProviderMetadata
		return ret
	}
	return *o.ProviderMetadata
}

// GetProviderMetadataOk returns a tuple with the ProviderMetadata field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *UpdateFullCveRecordResponseUpdatedContainersCna) GetProviderMetadataOk() (*GetCveRecordResponseContainersCnaProviderMetadata, bool) {
	if o == nil || IsNil(o.ProviderMetadata) {
		return nil, false
	}
	return o.ProviderMetadata, true
}

// HasProviderMetadata returns a boolean if a field has been set.
func (o *UpdateFullCveRecordResponseUpdatedContainersCna) HasProviderMetadata() bool {
	if o != nil && !IsNil(o.ProviderMetadata) {
		return true
	}

	return false
}

// SetProviderMetadata gets a reference to the given GetCveRecordResponseContainersCnaProviderMetadata and assigns it to the ProviderMetadata field.
func (o *UpdateFullCveRecordResponseUpdatedContainersCna) SetProviderMetadata(v GetCveRecordResponseContainersCnaProviderMetadata) {
	o.ProviderMetadata = &v
}

// GetReferences returns the References field value if set, zero value otherwise.
func (o *UpdateFullCveRecordResponseUpdatedContainersCna) GetReferences() []UpdateFullCveRecordResponseUpdatedContainersCnaReferencesInner {
	if o == nil || IsNil(o.References) {
		var ret []UpdateFullCveRecordResponseUpdatedContainersCnaReferencesInner
		return ret
	}
	return o.References
}

// GetReferencesOk returns a tuple with the References field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *UpdateFullCveRecordResponseUpdatedContainersCna) GetReferencesOk() ([]UpdateFullCveRecordResponseUpdatedContainersCnaReferencesInner, bool) {
	if o == nil || IsNil(o.References) {
		return nil, false
	}
	return o.References, true
}

// HasReferences returns a boolean if a field has been set.
func (o *UpdateFullCveRecordResponseUpdatedContainersCna) HasReferences() bool {
	if o != nil && !IsNil(o.References) {
		return true
	}

	return false
}

// SetReferences gets a reference to the given []UpdateFullCveRecordResponseUpdatedContainersCnaReferencesInner and assigns it to the References field.
func (o *UpdateFullCveRecordResponseUpdatedContainersCna) SetReferences(v []UpdateFullCveRecordResponseUpdatedContainersCnaReferencesInner) {
	o.References = v
}

// GetDataType returns the DataType field value if set, zero value otherwise.
func (o *UpdateFullCveRecordResponseUpdatedContainersCna) GetDataType() string {
	if o == nil || IsNil(o.DataType) {
		var ret string
		return ret
	}
	return *o.DataType
}

// GetDataTypeOk returns a tuple with the DataType field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *UpdateFullCveRecordResponseUpdatedContainersCna) GetDataTypeOk() (*string, bool) {
	if o == nil || IsNil(o.DataType) {
		return nil, false
	}
	return o.DataType, true
}

// HasDataType returns a boolean if a field has been set.
func (o *UpdateFullCveRecordResponseUpdatedContainersCna) HasDataType() bool {
	if o != nil && !IsNil(o.DataType) {
		return true
	}

	return false
}

// SetDataType gets a reference to the given string and assigns it to the DataType field.
func (o *UpdateFullCveRecordResponseUpdatedContainersCna) SetDataType(v string) {
	o.DataType = &v
}

// GetDataVersion returns the DataVersion field value if set, zero value otherwise.
func (o *UpdateFullCveRecordResponseUpdatedContainersCna) GetDataVersion() string {
	if o == nil || IsNil(o.DataVersion) {
		var ret string
		return ret
	}
	return *o.DataVersion
}

// GetDataVersionOk returns a tuple with the DataVersion field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *UpdateFullCveRecordResponseUpdatedContainersCna) GetDataVersionOk() (*string, bool) {
	if o == nil || IsNil(o.DataVersion) {
		return nil, false
	}
	return o.DataVersion, true
}

// HasDataVersion returns a boolean if a field has been set.
func (o *UpdateFullCveRecordResponseUpdatedContainersCna) HasDataVersion() bool {
	if o != nil && !IsNil(o.DataVersion) {
		return true
	}

	return false
}

// SetDataVersion gets a reference to the given string and assigns it to the DataVersion field.
func (o *UpdateFullCveRecordResponseUpdatedContainersCna) SetDataVersion(v string) {
	o.DataVersion = &v
}

func (o UpdateFullCveRecordResponseUpdatedContainersCna) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o UpdateFullCveRecordResponseUpdatedContainersCna) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.Affected) {
		toSerialize["affected"] = o.Affected
	}
	if !IsNil(o.Descriptions) {
		toSerialize["descriptions"] = o.Descriptions
	}
	if !IsNil(o.ProblemTypes) {
		toSerialize["problemTypes"] = o.ProblemTypes
	}
	if !IsNil(o.ProviderMetadata) {
		toSerialize["providerMetadata"] = o.ProviderMetadata
	}
	if !IsNil(o.References) {
		toSerialize["references"] = o.References
	}
	if !IsNil(o.DataType) {
		toSerialize["dataType"] = o.DataType
	}
	if !IsNil(o.DataVersion) {
		toSerialize["dataVersion"] = o.DataVersion
	}
	return toSerialize, nil
}

type NullableUpdateFullCveRecordResponseUpdatedContainersCna struct {
	value *UpdateFullCveRecordResponseUpdatedContainersCna
	isSet bool
}

func (v NullableUpdateFullCveRecordResponseUpdatedContainersCna) Get() *UpdateFullCveRecordResponseUpdatedContainersCna {
	return v.value
}

func (v *NullableUpdateFullCveRecordResponseUpdatedContainersCna) Set(val *UpdateFullCveRecordResponseUpdatedContainersCna) {
	v.value = val
	v.isSet = true
}

func (v NullableUpdateFullCveRecordResponseUpdatedContainersCna) IsSet() bool {
	return v.isSet
}

func (v *NullableUpdateFullCveRecordResponseUpdatedContainersCna) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableUpdateFullCveRecordResponseUpdatedContainersCna(val *UpdateFullCveRecordResponseUpdatedContainersCna) *NullableUpdateFullCveRecordResponseUpdatedContainersCna {
	return &NullableUpdateFullCveRecordResponseUpdatedContainersCna{value: val, isSet: true}
}

func (v NullableUpdateFullCveRecordResponseUpdatedContainersCna) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableUpdateFullCveRecordResponseUpdatedContainersCna) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


